# evscript

This repository contains a couple of simple Python 3 modules to help automate
GUI testing, using the `evdev` module (https://python-evdev.readthedocs.io/)
to mimic the user's interaction with a touchscreen.

## Install Dependencies

On the development board, install the `python3-evdev` package if it is not
already installed:

```
sudo apt-get install -y python3-evdev
```

Also ensure that the `uinput` module is being used by the kernel:

```
sudo modprobe uinput
```

## Running the Examples

The examples need to be run either as root or using `sudo`. The `evsupport.py`
and `phoshtester.py` modules need to be on the `PYTHONPATH`.

From the repository root installed in the `purism` user's account on the
Librem 5 development board, run the following when the screen is locked:

```
sudo PYTHONPATH=. examples/login.py
```

The initial screen should be swiped up and the default passcode entered.

## Interactive Use

It can be useful to experiment at the Python prompt by running the following
command to create a tester instance and start an interactive session:

```
sudo python3 -i -c 'import phoshtester; t = phoshtester.PhoshTester()'
```

The `t` instance has a number of methods that can be used to perform both
high and low level actions in the phone environment.

```
# Open the panel at the top of the screen:
t.open_panel()

# Tap a point on the screen:
t.tap(720, 200)
```

